#ifndef ANGLES_H_LOADED
#define ANGLES_H_LOADED 1

#include <stdlib.h>             // for size_t
#if PROVARINO
#include <string>
#endif

/**
 * Encapsulates a few angle conversion and formatting functions.
 */
namespace Angles
{
    double dms2r(int d, int m=0, double s=0.0, bool norm=false);
    double hms2r(int h, int m=0, double s=0);
    double r2d(double r);
    double d2r(double d);

    char* r2dms_b(char*, size_t, double angle, bool norm=false);
    char* r2hms_b(char*, size_t, double angle);
#if PROVARINO
    std::string r2dms(double angle, bool norm=false);
    std::string r2hms(double angle);
#endif
}

#endif /* ANGLES_H_LOADED */
