#ifndef EXCEPTION_H_LOADED
#define EXCEPTION_H_LOADED 1

// The only 'exception' handling is functions fatal(format, ...)
// and recoverable_error(format, ...); both are actually macros.

#include "types.h"

#define assert(e) ((e) ? (void)0 : (fatal(PSTR("assertion")), (void)0))

// fatal and recoverable_error are defined in exception.cpp
void qp_error(bool is_fatal, const char* file, unsigned int line, PGM_P format, ...);
#define fatal(...) qp_error(true, __FILE__, __LINE__, __VA_ARGS__)
#define recoverable_error(...) qp_error(false, __FILE__, __LINE__, __VA_ARGS__)

#endif /* EXCEPTION_H_LOADED */
