#ifndef TYPES_H_LOADED
#define TYPES_H_LOADED 1

#include <limits.h>

// The PROVARINO macro is defined within Arduino.h when we are building this code
// for the unit test cases.  It includes various C++ libraries (for
// example std::string and the std::cout objects) which are not
// available on the Arduino, but which we use when testing.
// the Arduino environment
#include <Arduino.h>
typedef unsigned long ms_t;
#if PROVARINO
#define MS_FMT "%lu"
#else
#define MS_FMT "%l"
#endif

// Early versions of the Arduino toolchain apparently don't define UINT32_MAX.
// I'm not too happy second-guessing things here unless we need to run on old Dues,
// but we do in fact know that the Arduino unsigned long is 32 bits.  So:
//#define UINT32_MAX 0xffffffff

// coded times: setting an action time to TIME_IMMEDIATELY means that
// it will be matched on the next time round the loop; setting it to
// TIME_NEVER means that it will never happen.  The former may go
// slightly wrong when the millis() time wraps around, just before 50
// days after starting, but nothing bad happens then).
#define TIME_IMMEDIATELY (ms_t)0
#define TIME_NEVER (ms_t)UINT32_MAX

#if __cplusplus > 199711L
// this is a C++11 compiler
#define OVERRIDE override
#else
#define OVERRIDE
#endif



#endif /* TYPES_H_LOADED */
